/// @addtogroup krak
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file manip.h
///
/// @author The CAPD Group
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file is part of the CAPD library.  This library is free software;
// you can redistribute it and/or modify it under the terms of the GNU
// General Public License as published by the Free Software Foundation;
// either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this software; see the file "license.txt".  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.

#ifndef _manip_h_
#define _manip_h_

namespace capd{
namespace krak{
class At{
public:
   int row,col;
   At(int r,int c);
};

class Tab{
public:
   int col;
   Tab(int c);
};

class FgColor{
public:
   int color;
   FgColor(int c);
};

class BgColor{
public:
   int color;
   BgColor(int c);
};

void SetBgCol(int col);
void SetFgCol(int col);

}} // the end of the namespace capd::krak

// ###############################  inline definitions ########################

inline capd::krak::At::At(int r,int c)
{
   row=r;col=c;
}

inline capd::krak::Tab::Tab(int c)
{
   col=c;
}

inline capd::krak::FgColor::FgColor(int c)
{
   color=c;
}

inline capd::krak::BgColor::BgColor(int c)
{
   color=c;
}

#endif

/// @}
