/// @addtogroup krak
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file atom.cpp
///
/// @author The CAPD Group
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file is part of the CAPD library.  This library is free software;
// you can redistribute it and/or modify it under the terms of the GNU
// General Public License as published by the Free Software Foundation;
// either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this software; see the file "license.txt".  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.

#include "krak/atom.h"
#include "capd/myc.h"

#ifdef IS_THIS_FILE_REALLY_NECESSARY // It does not even compile! - PwP

namespace capd{
namespace krak{
capd::krak::atom &get(std::istream &in)
{
   atom *result;
   char *wsk;
   int ch=in.get();

   switch(ch)
   {
      case ' ':break;
      case '\n':break;
      case '\r':break;
      case -1: result=NULL; break;
      case '"':
         ostrstream s;
         while((ch=in.get())!='"')
         {
            if(ch==')') ch=in.get();
            s << ch;
         }
         s << ends;
         wsk=s.str();
         result = new string(wsk);
         delete wsk;
         break;
      case '[':
         capd::krak::record *rec = new capd::krak::record;
         while(in.peek()!=']')
         {
            capd::krak::field *f = new capd::krak::field;
            capd::krak::atom *a = get(in);
            if(a.who!=STRING)
               capd::krak::errorExit("Found type %d instead of string",a.who());
            string *s=f;
            *s=*(string *)a;
            if(in.get()!=':')
               capd::krak::errorExit("Colon missing");
            f->value=get(in);
            rec.putfirst(*f);
         }
         in.get();
         result=rec;
         break;
      case '{':

      default:
   }
   return *result;
}

#endif

/// @}
