#include "symcov.h"

intervalVector linear_N1_N1(const intervalVector &v)
{
   intervalVector temp = N1->IM * v;
   return linearApproxN1*temp + N1->Icenter;
}

//###########################################################//

intervalVector linear_N1_H1(const intervalVector &v)
{
   intervalVector temp = N1->IM * v;
   return linearApproxN1*temp + H1->Icenter;
}

//###########################################################//

intervalVector linear_H1_H2(const intervalVector &v)
{
   intervalVector temp = H1->IM * v;
   return linearApproxH1*temp + H2->Icenter;
}

//###########################################################//

intervalVector linear_H2_H3(const intervalVector &v)
{
   intervalVector temp = H2->IM * v;
   return linearApproxH2*temp + H3->Icenter;
}

//###########################################################//

intervalVector linear_H3_N2(const intervalVector &v)
{
   intervalVector temp = H3->IM * v;
   return linearApproxH3*temp + N2->Icenter;
}

//###########################################################//

intervalVector linear_N2_N2(const intervalVector &v)
{
   intervalVector temp = N2->IM * v;
   return linearApproxN2*temp + N2->Icenter;
}

//###########################################################//

void writeText(const char text[])
{
   if(GRAPH) txt << text;
}

//###########################################################//

void cover_N1_N1()
{
   writeText("Unstable walls of N1 in covering relation N1 cover N1\n");
   computeImageOfUnstableWalls(N1,1,30,30,30,30,1,N1,linear_N1_N1,10,2);
   writeReport("Unstable walls of N1 done!\n");
   writeText("Stable walls of N1 in covering relation N1 cover N1\n");
   computeImageOfStableWalls  (N1,1,30,30,30,30,1,N1,10,2);
   writeReport("Stable walls of N1 done!\n");
}

//###########################################################//

void cover_N1_H1()
{
   writeText("Unstable walls of N1 in covering relation N1 cover H1\n");
   computeImageOfUnstableWalls(N1,1,120,120,120,120,1,H1,linear_N1_H1,80,2);
   writeReport("Unstable walls of N1 done!\n");
   writeText("Stable walls of N1 in covering relation N1 cover H1\n");
   computeImageOfStableWalls  (N1,1,120,120,120,120,1,H1,80,2);
   writeReport("Stable walls of N1 done!\n");
}

//###########################################################//

void cover_H1_H2()
{
   writeText("Unstable walls of H1 in covering relation H1 cover H2\n");
   computeImageOfUnstableWalls(H1,4,160,100,120,120,1,H2,linear_H1_H2,10,2);
   writeReport("Unstable walls of H1 done!\n");
   writeText("Stable walls of H1 in covering relation H1 cover H2\n");
   computeImageOfStableWalls  (H1,4,100,100,110,110,1,H2,10,2);
   writeReport("Stable walls of H1 done!\n");
}

//###########################################################//

void cover_H2_H3()
{
   writeText("Unstable walls of H2 in covering relation H2 cover H3\n");
   computeImageOfUnstableWalls(H2,1,250,15,50,50,1,H3,linear_H2_H3,13,2);
   writeReport("Unstable walls of H2 done!\n");
   writeText("Stable walls of H2 in covering relation H2 cover H3\n");
   computeImageOfStableWalls  (H2,1,40,40,40,20,1,H3,13,2);
   writeReport("Stable walls of H2 done!\n");
}

//###########################################################//

void cover_H3_N2()
{
   writeText("Unstable walls of H3 in covering relation H3 cover N2\n");
   computeImageOfUnstableWalls(H3,1,25,20,30,30,1,N2,linear_H3_N2,5,2);
   writeReport("Unstable walls of H3 done!\n");
   writeText("Stable walls of H3 in covering relation H3 cover N2\n");
   computeImageOfStableWalls  (H3,1,30,30,30,30,1,N2,5,2);
   writeReport("Stable walls of H3 done!\n");
}

//###########################################################//

void cover_N2_N2()
{
   writeText("Unstable walls of N2 in covering relation N2 cover N2\n");
   computeImageOfUnstableWalls(N2,1,20,20,20,20,1,N2,linear_N2_N2,10,2);
   writeReport("Unstable walls of N2 done!\n");
   writeText("Stable walls of N2 in covering relation N2 cover N2\n");
   computeImageOfStableWalls  (N2,1,20,20,20,20,1,N2,10,2);
   writeReport("Stable walls of N2 done!\n");
}

//###########################################################//

void cover()
{
   if(GRAPH) txt.Clear();
   cover_N1_N1();
   if(GRAPH) txt.Clear();
   cover_N1_H1();
   if(GRAPH) txt.Clear();
   cover_H1_H2();
   if(GRAPH) txt.Clear();
   cover_H2_H3();
   if(GRAPH) txt.Clear();
   cover_H3_N2();
   if(GRAPH) txt.Clear();
   cover_N2_N2();
   if(GRAPH)
   {
      txt << "\nProof is finished";
      waitBt();
   }
}
