#include "symcov.h"

//###########################################################//

Frame graph1, graph2,txt;
symSet *N1, *N2, *H1, *H2, *H3;
intervalMatrix linearApproxN1, linearApproxN2, linearApproxH1, linearApproxH2, linearApproxH3;
bool GRAPH=true;
double numberOfBoxes=0;

void writeReport(const char *tekst)
{
   std::ofstream file;
   file.open("report",std::ios::app);
   file << tekst;
   file.close();
}

//###########################################################//

void proof()
{
   cover(); // in file covering.cpp
   frstring f = "Number of boxes ";
   f << numberOfBoxes;
   writeReport(f.string());
}

//###########################################################//

void menu()
{
   if(GRAPH)
   {
      txt << "Set your choice:\n1 - nonrigorous simulations\n2 - rigorous proof\n3 - exit\n";
      int choice=0;
      while(choice!=1 && choice!=2 && choice!=3)
      {
         txt >> choice;
         switch(choice)
         {
            case 1 :{
// nonrigorous computations - visualisation of covering relations
               showImagesOfAllUnstableWalls(15);
               showImagesOfAllSets(10);
               return;
            }
            case 2: {
// rigorous computations
               proof();
               return;
            }
            case 3: return;
         } // end of switch
      } // end of while
   } else {
// if GRAPHICS is not defined
      std::cout << "The proof is running in background. The report will be stored in the file 'report'";
      proof();
   }
}

//###########################################################//

int main(int argc, char* argv[])
{
   if(argc>1 && !strcmp(argv[1],"nograph")) GRAPH=false;
   std::ofstream file;
   file.open("report");
   file << "The report from the proof of the existence of chaotic dynamics for a four dimensional map\n\n";
   file.close();

   if(GRAPH) initGraph();

   initSets();
   menu();
   deleteSets();

   if(GRAPH) closeGW();
   return 0;
}
